﻿class MyButton extends MovieClip {
	//stage instances
	private var background_mc:MovieClip;
	private var label_txt:TextField;
	//end stage instances
	private var __label:String = "";
	private var __bgcolor:Number = 0xFFFFFF;
	private var __bordercolor:Number = 0x000000;
	private var __borderwidth:Number = 1;
	private var __textcolor:Number = 0x000000;
	//get and set the label
	public function get label():String {
		return this.__label;
	}
	public function set label(value:String) {
		this.__label = value;
		if (this.label_txt) {
			this.label_txt.text = this.label;
		}
	}
	//change the background color
	public function get bgcolor():Number {
		return this.__bgcolor;
	}
	public function set bgcolor(value:Number) {
		this.__bgcolor = value;
		if (this.background_mc) {
			this.drawBackground();
		}
	}
	//change the border color
	public function get bordercolor():Number {
		return this.__bordercolor;
	}
	public function set bordercolor(value:Number) {
		this.__bordercolor = value;
		if (this.background_mc) {
			this.drawBackground();
		}
	}
	//change the border width
	public function get borderwidth():Number {
		return this.__borderwidth;
	}
	public function set borderwidth(value:Number) {
		this.__borderwidth = value;
		if (this.background_mc) {
			this.drawBackground();
		}
	}
	//change the text color
	public function get textcolor():Number {
		return this.__textcolor;
	}
	public function set textcolor(value:Number) {
		this.__textcolor = value;
		if (this.label_txt) {
			this.formatTextField();
		}
	}
	public function onLoad(success:Boolean) {
		//create the text field
		this.createTextField("label_txt", 1, 0, 0, 20, 20);
		this.label_txt.autoSize = "left";
		this.formatTextField();
		this.drawBackground();
	}
	private function formatTextField():Void {
		var label_fmt:TextFormat = new TextFormat();
		label_fmt.color = this.textcolor;
		this.label_txt.setNewTextFormat(label_fmt);
		this.label_txt.text = this.label;
	}
	private function drawBackground():Void {
		//create the background
		this.createEmptyMovieClip("background_mc", 0);
		var w:Number = this.label_txt._width;
		var h:Number = this.label_txt._height;
		with (this.background_mc) {
			if (this.borderwidth>0) {
				lineStyle(this.borderwidth, this.bordercolor);
			}
			beginFill(this.bgcolor, 100);
			moveTo(0, 0);
			lineTo(w, 0);
			lineTo(w, h);
			lineTo(0, h);
			lineTo(0, 0);
			endFill();
		}
	}
}
